/*
 * SwingExampleFrame.java
 *
 * Created on September 29, 2007, 4:56 PM
 */

package CCSC;

/**
 *
 * @author  rea
 */
public class SwingExampleFrame extends javax.swing.JFrame {
    
    private int m_numClicks = 0; // Keeps track of total num times button was clicked.
    private int m_seconds = 0; // Total seconds since timer started.
    
    /**
     * Creates new form SwingExampleFrame
     */
    public SwingExampleFrame() {
        initComponents();
        // Creates a timer that will go off every 1000 ms.
        // Each time the timer goes off the total number of seconds will be incremented
        // and the timer text field will be updated to display the total seconds elapsed.
        javax.swing.Timer t = new javax.swing.Timer(1000, new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                m_seconds++;
                timerEchoFormattedTextField.setValue(m_seconds + ": Seconds have passed");
            }});
            t.start();  // Start the timer
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        addButton = new javax.swing.JButton();
        buttonClicksLabel = new javax.swing.JLabel();
        quitButton = new javax.swing.JButton();
        numClicksFormattedTextField = new javax.swing.JFormattedTextField();
        horizontalSlider = new javax.swing.JSlider();
        horizontalFormattedTextField = new javax.swing.JFormattedTextField();
        horizontalLabel = new javax.swing.JLabel();
        verticalSlider = new javax.swing.JSlider();
        verticalLabel = new javax.swing.JLabel();
        verticalFormattedTextField = new javax.swing.JFormattedTextField();
        mouseEchoLabel = new javax.swing.JLabel();
        timerEchoLabel = new javax.swing.JLabel();
        mouseEchoFormattedTextField = new javax.swing.JFormattedTextField();
        timerEchoFormattedTextField = new javax.swing.JFormattedTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Swing_MouseAndTimer");
        addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                formMouseMoved(evt);
            }
        });

        addButton.setText("Click to Add");
        addButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addButtonActionPerformed(evt);
            }
        });

        buttonClicksLabel.setText("Button Clicks:");

        quitButton.setText("Quit");
        quitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                quitButtonActionPerformed(evt);
            }
        });

        horizontalSlider.setMaximum(10);
        horizontalSlider.setValue(0);
        horizontalSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                horizontalSliderStateChanged(evt);
            }
        });

        horizontalFormattedTextField.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        horizontalFormattedTextField.setText("0");

        horizontalLabel.setText("Horizontal Bar");

        verticalSlider.setOrientation(javax.swing.JSlider.VERTICAL);
        verticalSlider.setValue(0);
        verticalSlider.setInverted(true);
        verticalSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                verticalSliderStateChanged(evt);
            }
        });

        verticalLabel.setText("Vertical Bar");

        verticalFormattedTextField.setHorizontalAlignment(javax.swing.JTextField.CENTER);
        verticalFormattedTextField.setText("0");

        mouseEchoLabel.setText("Mouse Echo:");

        timerEchoLabel.setText("Timer Echo:");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(verticalFormattedTextField, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 56, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(verticalSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18))
                    .addComponent(verticalLabel, javax.swing.GroupLayout.Alignment.LEADING))
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(43, 43, 43)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addGap(43, 43, 43)
                                .addComponent(addButton)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(buttonClicksLabel)
                                .addGap(24, 24, 24)
                                .addComponent(numClicksFormattedTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGap(72, 72, 72)
                                .addComponent(horizontalSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(horizontalLabel)))
                        .addGap(14, 14, 14)
                        .addComponent(quitButton))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(139, 139, 139)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(mouseEchoLabel)
                                    .addComponent(timerEchoLabel))
                                .addGap(26, 26, 26)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(timerEchoFormattedTextField)
                                    .addComponent(mouseEchoFormattedTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 182, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addComponent(horizontalFormattedTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 56, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {addButton, numClicksFormattedTextField});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(verticalFormattedTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(addButton)
                    .addComponent(buttonClicksLabel)
                    .addComponent(numClicksFormattedTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(28, 28, 28)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(verticalSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(verticalLabel))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(mouseEchoFormattedTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(mouseEchoLabel))
                        .addGap(16, 16, 16)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(timerEchoFormattedTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(timerEchoLabel))
                        .addGap(31, 31, 31)
                        .addComponent(horizontalFormattedTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(quitButton)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(horizontalLabel)
                                .addComponent(horizontalSlider, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(2, 2, 2)))
                .addContainerGap(21, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void formMouseMoved(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_formMouseMoved
// Update the mouse text field each time the mouse moves
        mouseEchoFormattedTextField.setValue("Mouse move at  " + evt.getX() + " , " + evt.getY());
    }//GEN-LAST:event_formMouseMoved
    
    private void verticalSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_verticalSliderStateChanged
// Update the vertical slider text field each time the vertical slider changes
        verticalFormattedTextField.setValue(verticalSlider.getValue());
    }//GEN-LAST:event_verticalSliderStateChanged
    
    private void horizontalSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_horizontalSliderStateChanged
// Update the horizontal slider text field each time the horizontal slider changes
        horizontalFormattedTextField.setValue(horizontalSlider.getValue());
    }//GEN-LAST:event_horizontalSliderStateChanged
    
    private void addButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addButtonActionPerformed
        // Increment the counter and update the text field each time the add
        // button is clicked.
        m_numClicks = m_numClicks + 1;
        numClicksFormattedTextField.setValue(m_numClicks);
        
    }//GEN-LAST:event_addButtonActionPerformed
    
    private void quitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_quitButtonActionPerformed
// Exit when quitButton is clicked
        System.exit(0);
    }//GEN-LAST:event_quitButtonActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new SwingExampleFrame().setVisible(true);
            }
        });
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addButton;
    private javax.swing.JLabel buttonClicksLabel;
    private javax.swing.JFormattedTextField horizontalFormattedTextField;
    private javax.swing.JLabel horizontalLabel;
    private javax.swing.JSlider horizontalSlider;
    private javax.swing.JFormattedTextField mouseEchoFormattedTextField;
    private javax.swing.JLabel mouseEchoLabel;
    private javax.swing.JFormattedTextField numClicksFormattedTextField;
    private javax.swing.JButton quitButton;
    private javax.swing.JFormattedTextField timerEchoFormattedTextField;
    private javax.swing.JLabel timerEchoLabel;
    private javax.swing.JFormattedTextField verticalFormattedTextField;
    private javax.swing.JLabel verticalLabel;
    private javax.swing.JSlider verticalSlider;
    // End of variables declaration//GEN-END:variables
    
}
